2004-01-07  Nick Drochak <ndrochak@ieee.org>

	* genericparser.cs:
	* mb-tokenizer.cs: 
	* row.cs: Eliminate warnings about unused variables.

2004/01/06  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* typemanager.cs : 	correcting translation of System types to language types, 
			also temporarily circunventing a exception in ModuleBuilder.GetType inside LookupTypeReflection,
			corrected many ` characters to ' in error messages
	* testmbas/WriteOK.vb : testing newly implemented IsNumeric global function

2004-01-04  David Sheldon <dave-mono@earth.li>

  * expression.cs: Added matching ")" to error message for 
  CS0077

2003/12/23  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* driver.cs : added stubs for options "/netcf /sdkpath:path"
	* namespace.cs, decl.cs, rootcontext.cs : use hashtable to avoid duplicate importation of namespaces 
	  (especially between command-line option /imports and explicit Import clauses), what manifested itself as
	  error messages for ambiguous names that where in truth identical
	* statement.cs : trying to fix the 'exit' statement DoEmit, for "Exit Sub"
	* mb-parser.jay, mb-tokenizer.cs : initial support for type_characters (dim az$ = dim az as string)

2003/12/18  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* class.cs : case-sensitiveness when tracking the entry-point removed
	* driver.cs : IsSWFApp would try to pass a null 'mainclass' to the hashtable indexer, throwing an exception
		(even for correct programs because of the bug above). Now this condition is tested before

2003/12/06  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* ecore.cs : problems trying to implicit convert OMITTED arguments, solved
	* mb-tokenizer.cs, mb-parser.jay, typemanager.cs : support for the date primitive type and date literals
	* testmbas/WriteOK.vb: testing date type and date literal

2003/11/12  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* driver.cs : /imports option now is implemented
	* mb-parser.jay: support for pre-imported namespaces (the default Microsoft.VisualBasic and those from /imports)
	
2003/11/12  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* mb-tokenizer.cs : integer literal (Hex starts with &H not 0x), handle Octal literals (&O)
	* 	handle unicode specialized double-quotes in string literals	
	* 	corrected some mishandling of conversions in numeric literals
	*	implemented support for char literals ("z"c)
	* Makefile : verbose target uses verbose argument
	* testmbas/WriteOK.vb: many tests for literals implemented
	* literal.cs: correcting lack of a ShortLiteral class
	* mb-parser.jay: removed support for unsigned int literals, added support for short int literals
	
2003/11/10  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* *.cs, mb-parser.jay: Switched all from defining/using namespace Mono.CSharp to Mono.MonoBASIC 
	* location.cs: SymbolDocument now returns a SymbolDocumentWriter using the right (SymLanguageType.Basic) GUID
	
2003/10/17  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* genericparser.cs: 
	    Don't print exception when a file is not found to be parsed
		File extensions not matched are now processed with the default parser
		Better handle file/directory not found exceptions, and use Report.Error in that case
	* added defaultparserattribute.cs
	* mb-parser.jay : Mono.MonoBASIC.Parser is now the [DefaultParser]
	* location.cs version 1.4 recovered (Marco Ridoni had it overwritten with an older version)
	* mb-tokenizer.cs, rootcontext.cs, tree.cs: Location constructor needs column number now

2003/09/17  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* .cvsignore: WHOOPS

2003/09/17  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* .cvsignore: some more files to ignore

2003/09/17  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* mb-tokenizer.cs, driver.cs: Back to Linux line-endings, SORRY

2003/09/16  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* Makefile: corrected testing in Windows/Cygwin (from mbas.exe to ./mbas.exe), because it was getting the installed compiler instead of the compiled one
	* mb-tokenizer.cs: Redoing: Preprocessor directives must be case-insensitive (many .ToLower() used)
	* driver.cs: No more 'linkpaths' option, use 'libpath' instead

2003/09/15  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* driver.cs: Corrected handling of FileNotFoundException in LoadAssembly(), according to Bernie Solomon's patch

2003/08/13  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* mb-parser.jay: ReDim statement parses many variables now (but initializers aren't allowed)
					 Erase statement implemented
					 Lots of garbage (never reduced rules) deleted
					 Reduce/Reduce problems eliminated (where due to having opt_modifiers duplicated inside property_declaration rule)
	* statement.cs : class Redim is prepared to have ReDim Preserve copying code called,
					 but we need to check if that code is lying in Microsoft.VisualBasic.dll
					 New class Erase

2003-07-26  Ben Maurer  <bmaurer@users.sourceforge.net>
	
	* statement.cs: Make Math.XXX System.Math.XXX, to fix the build.
	
2003-07-20  Peter Williams  <peter@newton.cx>

	* Makefile: Remove the test target which conflicted with
	the global target. (Change confirmed with Rafael.)

2003-04-02  Duncan Mak  <duncan@ximian.com>

	* mb-parser.jay: Temporarily remove the references to
	Class.MustOverride to fix the build.

2003/03/29  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* mb-parser.jay: corrected some module related rules
	* location.cs : now handles column information
	
2003/03/11  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* makefile.gnu : use $RUNTIME for all targets
					 actually run the compiled program on 'test-gtk' target 
	* mb-tokenizer.cs : no escaping of chars allowed in VB.NET (old mcs code removed)
						handle doubled-doublequotes (VB idiom to escape a doublequote) 
	
2003/03/04  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* mb-parser.jay: added rule for Imports with alias
	* mb-parser.jay: Friend (internal) modifier was missing,
					 Shared modifier was expecting Static token erroneously
					 Modules must accept only a static constructor rule added
					 Constant declaration rule added
	* makefile & makefile.gnu : actually run the compiled program on test target 

2003/03/03  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* mb-tokenizer.cs : new semi-keywords: Compare, Explicit, Strict, On, Off, Binary, Text
	* mb-parser.jay: tokens for above semi-keywords, and rules for option directives
	* driver.cs: integrates command line options with parser flags for option directives
	* makefile & makefile.gnu : added 'verbose' target that uses --verbose switch to compile 
	  the test source and pipes it through 'less', also added a Extended Syntax source

2003/02/22  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* class.cs : As, per vbc, there is a rootnamespace now, --main wasn't working anymore, 
				 because it was expecting a fully qualified class name. 
				 We now also test the name passed prepended by the rootnamespace.
	* class.cs : Corrected warning "The keyword new is required on `Mono.CSharp.Property.Emit'
				 because it hides inherited member `PropertyBase.Emit'", by making it virtual
				 in PropertyBase and override in Property.
	* makefile.gnu : test and test-gtk targets now depend on mbas.exe
				 

2003/02/19  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* mb-parser.jay : eliminated reduce/reduce conflict on duplicated rank_specifier rule
	  by renaming the one using brackets to bracketed_rank_specifier

2003/02/12  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* added argument.cs (extracted from expression.cs) makefiles corrected
	* mb-parser.jay : eliminated reduce/reduce conflict on opt_argument_list rule, 
	  by putting and if to make a argument list with just an empty argument list become an empty list

2003/02/03  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* rootcontext.cs : added RootNamespace member
	* mb-parser.jay : use RootContext.RootNamespace to initialize outermost namespace
	* driver.cs : 
		- implement rootnamespace parameter, and defaults it to the output file name
		- like vbc if no source file name is provided just show help

2003/01/22  Nick Drochak <ndrochak@gol.com>
	* makefile: Use csc compiler in here. makefile.gnu assumes mono/mcs

2003-01-13  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* added cleanup method to tokenizer as needed but modifications made in jay

2003-01-12  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* changed test target in makefile work
        * corrected authors list to include Marco

2002-10-23  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged many sources from mcs/mcs, to resync

2002-10-20  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* using Mono.GetOptions preliminar support for response files, 
	  changed the makefile target 'test' for use o response file testmbas/filelist

2002-10-20  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged many sources from mcs/mcs, to resync

2002-10-05  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged many sources from mcs/mcs, to resync

2002-08-31  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged many sources from mcs/mcs, to resync

2002-09-03  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* integrated new version of Mono.GetOptions (reflection/attributes-based)

2002-08-31  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged expression.cs from mcs/mcs, to resync

2002-08-29  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged assign.cs, attribute.cs, class.cs, codegen.cs, const.cs, decl.cs, delegate.cs, ecore.cs, enum.cs,
        expression.cs, interface.cs, pending.cs, report.cs, rootcontext.cs, statement.cs, support.cs and 
        typemanager.cs from mcs/mcs, to resync

2002-08-06  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* added "test" target to makefile
	* merged assign.cs, attribute.cs, cfold.cs, class.cs, codegen.cs, const.cs, constant.cs, 
	  decl.cs, delegate.cs, ecore.cs, enum.cs, expression.cs, interface.cs, modifiers.cs, parameter.cs, 
	  pending.cs, report.cs, rootcontext.cs, statement.cs, support.cs and typemanager.cs from mcs/mcs, to resync

2002-07-14  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged assign.cs, class.cs, ecore.cs, expression.cs, statement.cs and typemanager from mcs/mcs, to resync

2002-07-09  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged attribute.cs, ecore.cs, namespace.cs and statement.cs from mcs/mcs, to resync

2002-07-06  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged attribute.cs, class.cs, codegen.cs, ecore.cs, expression.cs, 
	  modifiers.cs, namespace.cs, report.cs, rootcontext.cs, statement.cs and typemanager.cs from mcs/mcs, to resync
	* changed driver.cs to follow mcs lead on error/warning counting and reporting

2002-06-23  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged attribute.cs, class.cs, ecore.cs, rootcontext.cs, support.cs and typemanager.cs from mcs/mcs, to resync
	* makefile makes csc reference a copy of Mono.GetOptions.dll (mbas.sln now compiles to mbas dir instead of mbas/bin/Debug)

2002-06-21  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged attribute.cs, class.cs, interface.cs, expression.cs, ecore.cs, 
	  modifiers.cs, rootcontext.cs, statement.cs and typemanager.cs from mcs/mcs, to resync
	* added pending.cs from mcs/mcs, to resync

2002-06-15  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged assign.cs, attribute.cs, enum.cs and namespace.cs from mcs/mcs, to resync
	* namespace.cs needed some fixing, because CSharpParser isn?t available

2002-06-15  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged delegate.cs, ecore.cs, typemanager.cs and rootcontext.cs from mcs/mcs, to resolve expression.cs blues

2002-06-15  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* oops merged expression.cs from mcs/mcs is breaking my make
	* driver.cs, assemblyinfo.cs wasn?t ready for prime time (offending lines were commented out)

2002-06-15  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged expression.cs from mcs/mcs

2002-06-12  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* corrected Module.TypeAttr property getter in module.cs
	
2002-06-12  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged typemanager.cs from mcs/mcs

2002-06-10  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged expression.cs and interface.cs from mcs/mcs

2002-06-09  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged const.cs, enum.cs, expression.cs and typemanager.cs from mcs/mcs
    * comments on module.cs

2002-06-07  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged class.cs, attribute.cs from mcs/mcs

2002-06-07  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged class.cs, enum.cs, expression.cs, interface.cs, rootcontext.cs and typemanager.cs from mcs/mcs
	* added module.cs (class Mono.MonoBASIC.Module - derived from Mono.CSharp.Class)
	* added System.XML and Microsoft.VisualBasic to the default config (driver.cs)
	
2002-06-07  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged class.cs and ecore.cs from mcs/mcs

2002-06-02  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* copied methods MakeName and CheckDef from mcs\cs-parser.jay to GenericParser.cs 
	  where they are inherited by mb-parser.jay/cs
	* put some code on the Module rule in mb-parser.jay to at least generate a class in the assembly,
	  if I jump over the entry-point check code, while debugging
	
2002-05-31  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* class Mono.MonoBASIC.Tokenizer now handles 
		- all valid line-terminators (CR, LF, CRLF, LS and PS)
		- escaped identifiers (like [Integer])
		- old-fashioned comments syntax (REM Blah-Blah)

2002-05-31  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* modified mbas.ico to be a small version of mono?s logo (see mcs\MonoIcon.png)

2002-05-31  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* squashed some reduce/reduce conflicts out of mb-parser.jay

2002-05-31  Rafael Teixeira <rafaelteixeirabr@hotmail.com>
	* merged codegen.cs from mcs
	* altered Driver.cs to work with new codegen.cs

2002-05-27  Rafael Teixeira <rafaelteixeirabr@hotmail.com>

	* merged all I could from mcs source files into mbas
	* added VS.NET Solution and Project Files for mbas
	* added icon file and a vb-sources-filled testmbas directory
	* started this ChangeLog
